﻿class Leaf extends MovieClip
{
	private static var LEAF_LIMITX1:Number = -40;
	private static var LEAF_LIMITX2:Number = 640;
	private static var LEAF_LIMITY:Number = 480;
	private static var LEAF_MINWIND:Number = -10;
	private static var LEAF_MAXWIND:Number = 10;
	private static var LEAF_GRAVITY:Number = 5;
	private static var LEAF_WINDADJBASE:Number = 4;
	private static var LEAF_WINDADJHALF:Number = 2;
	private static var LEAF_SCREENWIDTH:Number = 640;
	var wind:Number;
	
	function Leaf()
	{
		wind = 0;		
	}
	
	function onEnterFrame()
	{
		moveLeaves();
	}
	
	function moveLeaves()
	{
		var windAdj = Math.random() * LEAF_WINDADJBASE - LEAF_WINDADJHALF;
		wind = Math.max(Math.min(wind + windAdj, LEAF_MAXWIND), LEAF_MINWIND);
		var newX = _x + wind;
		if (newX < LEAF_LIMITX1)
			newX += LEAF_SCREENWIDTH;
		if (newX > LEAF_LIMITX2)
			newX -= LEAF_SCREENWIDTH;
		_x = newX;
		_y += LEAF_GRAVITY;
		if (_y > LEAF_LIMITY)
			_y = 0;
	}
}
