﻿class CoverLayer extends MovieClip
{
	var cover_array:Array;
	var cover_count:Number;
	var myDate:Date;
	
	function CoverLayer()
	{
		cover_array = new Array(64);
		for (var cntr = 0; cntr < 64; ++cntr)
		{
			cover_array[cntr] = attachMovie("Cover", "T"+cntr, cntr+1);
			cover_array[cntr]._x = cntr % 8 * 80;
			cover_array[cntr]._y = Math.floor(cntr / 8) * 60;
		}
	}
	
	function restart()
	{
		var cntr:Number;
		var rnd:Number;
		var temp;
		
		cover_count = 64;
		for (cntr = 0; cntr < 64; ++cntr)
		{
			cover_array[cntr]._visible = true;
		}
		for (cntr = 0; cntr < 64; ++cntr)
		{
			rnd = Math.floor(Math.random() * 64);
			temp = cover_array[cntr];
			cover_array[cntr] = cover_array[rnd];
			cover_array[rnd] = temp;
		}
		
		myDate = new Date();
	}
	
	/*
	* removes a covering block. 
	* Returns number of blocks remaining
	*/
	function removeBlock():Number
	{
		trace("removeBlock called");
		if (cover_count > 0)
		{
			cover_array[64-cover_count]._visible = false;
			--cover_count;
			return cover_count;
		}
		else
			return 0;
	}
	
	public function getScore():Number
	{
		var curDate:Date = new Date();
		var score:Number;
		score = 200000 - (curDate.getTime() - myDate.getTime());
		if (score < 0)
			score = 0;
		return score;
	}
}
